require 'ejs'

# load Rails/Railtie
begin
  require 'rails'
rescue LoadError
  #do nothing
end

module Silverdot
  autoload :Alternative, 'silverdot/alternative'
  autoload :ActionViewExtension, 'silverdot/helpers/action_view_extension'
  autoload :UrlHelper, 'silverdot/helpers/url_helper'
  autoload :LocalizeHelper, 'silverdot/helpers/localize_helper'
  autoload :ImageHelper, 'silverdot/helpers/image_helper'

  class << self
    def ejs_options
      { interpolation_pattern: /{{([\s\S]+?)}}/ }
    end
  end
end

if defined? Rails
  require 'silverdot/railtie'
  require 'silverdot/engine'
end
