require 'action_view/helpers/capture_helper'

module Silverdot
  class Alternative < String
    include ::ActionView::Helpers::CaptureHelper

    attr_accessor :output_buffer

    def initialize(name)
      @name = name
    end

    def method_missing(m, *args, &block)
      if /\A[a-z_]+\z/ =~ m
        child = Alternative.new(m)
        child.parent = self
        child
      else
        super(m, *args, &block)
      end
    end

    def [](index)
    end

    def []=(index, value)
    end

    def <<(value)
    end

    def sort!
    end

    def parent
      @parent
    end

    def parent=(value)
      @parent = value
    end

    def prefix
      "#{@parent.path}." unless @parent.nil?
    end

    def path
      "#{prefix}#{@name}"
    end

    def each(&block)
      block_name = block.parameters.first[1]
      child = Alternative.new(block_name.to_s)
      child.parent = self
      content = capture(child, &block)
      "{{ _.each(#{path}, function(#{block_name}){ }}#{content}{{ } }}"
    end

    def to_s
      "{{ #{path} }}"
    end

    def to_str
      to_s
    end

    def blank?
      path.blank?
    end
  end
end
