module Silverdot
  module ActionViewExtension
    def emboss(template, options = {})
      with = options[:with]
      with = [with] unless with.is_a?(Enumerable)
      locals = Hash[with.inject([]) do |list, name|
        list << [name.to_sym, Alternative.new(name)]
      end ]
      view = view_renderer.render(self, partial: template, locals: locals)
      if options[:jst]
        to_jst template, raw(::EJS.compile(view.to_str, Silverdot.ejs_options))
      else
        view
      end
    end

    protected

    def to_jst path, context
      namespace = "JST"
      <<-JST
<script>(function() { #{namespace} || (#{namespace} = {}); #{namespace}['#{path}'] = #{context};}).call(this);</script>
      JST
    end
  end
end
