module Silverdot
  module ImageHelper
    def self.included(base)
      base.alias_method_chain :image_path, :alternative
      base.alias_method_chain :image_alt, :alternative
    end

    def image_path_with_alternative(source)
      case source
      when Alternative
        source.src
      else
        image_path_without_alternative(source)
      end
    end
    alias :path_to_image :image_path_with_alternative

    def image_alt_with_alternative(src)
      case src
      when Alternative
        src.parent.alt
      else
        image_alt_without_alternative(src)
      end
    end
  end
end
